from collections import deque

MOD = 998_244_353

def bfs_order(tree):
    n = len(tree)
    vis = [False for _ in tree]
    parent = [None for _ in tree]

    q = deque([0])
    vis[0] = True
    order = []

    while q:
        u = q.popleft()
        order.append(u)
        for v in tree[u]:
            if vis[v]:
                parent[u] = v
            else:
                vis[v] = True
                q.append(v)

    return order

def main():
    n = int(input())
    tree = [[] for _ in range(n)]
    for _ in range(1, n):
        a, b = map(int, input().split())
        a -= 1
        b -= 1
        tree[a].append(b)
        tree[b].append(a)

    order = bfs_order(tree)
    dp = [None for _ in tree]
    for u in reversed(order):
        children = [dp[v] for v in tree[u] if dp[v] is not None]
        if children:
            pref_prod = [1]
            for x, y in children:
                pref_prod.append(pref_prod[-1] * (x + y) % MOD)
            suff_prod = 1

            dp1 = 0
            for i in range(len(children) - 1, -1, -1):
                dp1 += pref_prod[i] * children[i][1] * suff_prod
                dp1 %= MOD
                suff_prod = suff_prod * sum(children[i]) % MOD

            dp[u] = (pref_prod[-1], dp1)
        else:
            dp[u] = (1, 1)

    print(dp[0][0])

if __name__ == '__main__':
    main()
