#include <iostream>
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#endif

// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif

#define rep(i,a,b) for(int i = a; i <(b);++i)
#define repR(i,a,b) for(int i = a-1; i >= b;--i)
#define sz(x) (int)(x).size()
#define pb push_back
#define F first
#define S second
#define all(x) begin(x), end(x)

using ll = long long;


using namespace std;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<ll> vl;
ll MOD = 998244353;
void dfs(int cur, int p, vector<vl>& dp, vector<vi>& adj) {
    if (adj[cur].size() == 1 && p != -1) {
        dp[cur][0] = 1;
        dp[cur][1] = 1;
        return;
    }
    for (int a : adj[cur]) {
        if (a == p) continue;
        dfs(a,cur,dp,adj);
    }
    vl suff(adj[cur].size());
    ll acc = 1;
    repR(i,adj[cur].size(),0) {
        if (adj[cur][i] == p) continue;
        suff[i] = acc;
        ll next = dp[adj[cur][i]][0]+dp[adj[cur][i]][1];
        acc = (acc*next)%MOD;
    }
    dp[cur][0] = acc;
    acc = 1;
    rep(i,0,adj[cur].size()) {
        if (adj[cur][i] == p) continue;
        ll inc = ((acc*suff[i])%MOD*dp[adj[cur][i]][1])%MOD;
        dp[cur][1] = (dp[cur][1]+inc)%MOD;
        ll next = dp[adj[cur][i]][0]+dp[adj[cur][i]][1];
        acc = (acc*next)%MOD;
    }
}

void solve() {
    int n; cin>>n;
    vector<vi> adj(n);
    rep(i,0,n-1) {
        int a; int b; cin>>a>>b; a--; b--;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    vector<vl> dp(n,vl(2));
    dfs(0,-1,dp,adj);
    cout<<dp[0][0]<<'\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while(t--)
        solve();
    return 0;
}
